<template>
  <v-dialog
    ref="addProductDialog"
    v-model="dialog"
    persistent
    max-width="900px"
  >
    <v-card>
      <v-form ref="form">
        <v-card-title class="text-left info pb-2">
          <h2
            class="headline"
            text-color="white"
          >
            THÊM SẢN PHẨM
          </h2>
        </v-card-title>

        <v-divider />

        <v-card-text>
          <v-container class="pt-0 pb-0 mb-0">
            <v-col
              cols="12"
              lg="12"
              class="ml-2 mr-5 light-gray pb-0"
            >
              <v-row class="cols">
                <v-col
                  cols="12"
                  lg="5"
                  class="pl-0 pt-0 pb-0 pr-5"
                >
                  <v-row class="pl-2 pt-0 pb-0 pr-5 cols">
                    <span>Hình ảnh</span>
                  </v-row>
                  <v-row class="pl-2 pt-0 pb-0 pr-5 cols">
                    <v-col
                      cols="12"
                      class="text-center pt-0 pb-0 pl-0 main-thumb"
                    >
                      <div
                        :style="{ 'background-image': `url(${imageData1})` }"
                        class="image-input m-auto rounded-lg"
                        width="500px"
                        @click="chooseImage('THUMB_1')"
                      >
                        <span
                          v-if="!imageData1"
                          class="placeholder"
                        >
                          PIC
                        </span>
                        <input
                          ref="fileInput1"
                          class="file-input"
                          type="file"
                          @input="onSelectFile1"
                        >
                      </div>
                    </v-col>
                    <v-col
                      cols="3"
                      class="pb-0 pl-0 pr-0"
                    >
                      <div
                        :style="{ 'background-image': `url(${imageData2})` }"
                        class="image-input m-auto rounded-lg thumb"
                        @click="chooseImage('THUMB_2')"
                      >
                        <span
                          v-if="!imageData2"
                          class="placeholder rounded-lg"
                        >
                          PIC
                        </span>
                        <input
                          ref="fileInput2"
                          class="file-input"
                          type="file"
                          @input="onSelectFile2"
                        >
                      </div>
                    </v-col>
                    <v-col
                      cols="3"
                      class="pb-0 pl-0 pr-0"
                    >
                      <div
                        :style="{ 'background-image': `url(${imageData3})` }"
                        class="image-input m-auto rounded-lg thumb"
                        @click="chooseImage('THUMB_3')"
                      >
                        <span
                          v-if="!imageData3"
                          class="placeholder rounded-lg"
                        >
                          PIC
                        </span>
                        <input
                          ref="fileInput3"
                          class="file-input"
                          type="file"
                          @input="onSelectFile3"
                        >
                      </div>
                    </v-col>
                    <v-col
                      cols="3"
                      class="pb-0 pl-0 pr-0"
                    >
                      <div
                        :style="{ 'background-image': `url(${imageData4})` }"
                        class="image-input m-auto rounded-lg thumb"
                        @click="chooseImage('THUMB_4')"
                      >
                        <span
                          v-if="!imageData4"
                          class="placeholder rounded-lg"
                        >
                          PIC
                        </span>
                        <input
                          ref="fileInput4"
                          class="file-input"
                          type="file"
                          @input="onSelectFile4"
                        >
                      </div>
                    </v-col>
                    <v-col
                      cols="3"
                      class="pb-0 pl-0 pr-0"
                    >
                      <div
                        :style="{ 'background-image': `url(${imageData5})` }"
                        class="image-input m-auto rounded-lg thumb"
                        @click="chooseImage('THUMB_5')"
                      >
                        <span
                          v-if="!imageData5"
                          class="placeholder rounded-lg"
                        >
                          PIC
                        </span>
                        <input
                          ref="fileInput5"
                          class="file-input"
                          type="file"
                          @input="onSelectFile5"
                        >
                      </div>
                    </v-col>
                  </v-row>
                </v-col>
                <v-col
                  cols="12"
                  lg="7"
                  class="pl-0 pt-0 pb-0 pr-5"
                >
                  <v-row class="cols">
                    <v-text-field
                      ref="codeModal"
                      v-model="productModel.code"
                      label="Mã hàng (*)"
                      required
                      readonly
                      disabled
                      :rules="nameRules"
                    />
                  </v-row>
                  <v-row class="cols">
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-autocomplete
                        ref="spec"
                        v-model="productModel.specification"
                        :items="specification"
                        label="ĐVT"
                        multiple
                        required
                        :rules="dvtRules"
                      />
                    </v-col>
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-text-field
                        ref="net"
                        v-model="productModel.net"
                        label="KL Tịnh"
                        :rules="nameRules"
                      />
                    </v-col>
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 pr-0 col"
                    >
                      <v-text-field
                        ref="qtyinventory"
                        v-model="productModel.quota_whosale"
                        label="Tồn kho tối thiểu"
                        required
                        :rules="nameRules"
                      />
                    </v-col>
                  </v-row>
                  <v-row>
                    <v-autocomplete
                      ref="category"
                      v-model="productModel.category_code"
                      :items="category"
                      label="Danh mục"
                      required
                      :rules="nameRules"
                    />
                  </v-row>
                  <!-- Giá cả -->
                  <v-row
                    class="cols"
                  >
                    <v-col
                      sm="4"
                      md="4"
                      class="pl-0"
                    >
                      <v-text-field
                        v-model="productModel.real_price"
                        label="Giá vốn"
                        class="pr-5 text-right"
                        value="0"
                      />
                    </v-col>
                    <v-col
                      sm="4"
                      md="4"
                    >
                      <v-text-field
                        v-model="productModel.wholesale_price"
                        label="Giá sỉ"
                        class="pr-5"
                        value="0"
                      />
                    </v-col>
                    <v-col
                      sm="4"
                      md="4"
                      class="pr-0"
                    >
                      <v-text-field
                        v-model="productModel.retail_price"
                        label="Giá lẻ"
                        value="0"
                      />
                    </v-col>
                  </v-row>
                  <v-row>
                    <v-autocomplete
                      ref="suppiler"
                      v-model="productModel.suppiler_code"
                      :items="suppiler_code"
                      label="Nhà cung cấp"
                      multiple
                      required
                      :rules="nameRules"
                    />
                  </v-row>
                </v-col>
              </v-row>

              <v-row class="mt-5">
                <v-text-field
                  ref="nameproduct"
                  v-model="productModel.name_product"
                  :rules="nameRules"
                  label="Tên hàng (*)"
                  required
                  clearable
                  autofocus
                />
              </v-row>
              <v-row>
                <v-textarea
                  ref="soTienModal"
                  v-model="productModel.note"
                  rows="3"
                  label="Ghi chú"
                  class="font-2em"
                  clearable
                />
              </v-row>
            </v-col>
          </v-container>
        </v-card-text>

        <v-divider />

        <v-card-actions>
          <v-spacer />

          <v-btn
            color="primary"
            class="mr-0"
            @click="insertProduct"
          >
            Thêm
            <v-icon right>
              save
            </v-icon>
          </v-btn>

          <v-btn
            color="error"
            @click.native="dialog = false"
          >
            Đóng
            <v-icon right>
              clear
            </v-icon>
          </v-btn>
        </v-card-actions>
      </v-form>
    </v-card>
  </v-dialog>
</template>

<script>
  import axios from 'axios'
  import config from '../../config/config.js'

  export default {
    layout: 'dashboard',
    components: {},
    data () {
      return {
        valid: false,
        dialog: false,
        imageData1: null,
        imageData2: null,
        imageData3: null,
        imageData4: null,
        imageData5: null,
        specification: ['GÓI', 'THÙNG', 'KG', 'CÁI', 'HỘP'],
        suppiler_code: ['NCC1'],
        category: ['Bánh Gấu', 'Khô Gà', 'Cơm Cháy'],
        nameRules: [(v) => !!v || 'The field is required'],
        dvtRules: [(v) => !!v || 'The field is required'],
        seqOb: {
          seqCode: 'SP',
          seqName: 'product_code_seq',
          seqDigitNumber: 5,
        },
        productModel: {},
      }
    },
    computed: {},
    mounted: function () {}, // end method
    created () {}, // end data
    methods: {
      async insertProduct () {
        console.log('insertProduct')
        this.validate()
        // eslint-disable-next-line no-unused-vars
        const chitieu = JSON.stringify(this.chitieuModel)
        const seft = this
        // eslint-disable-next-line no-unused-vars
        var noteNew = seft.productModel.note.note
        // seft.productModel.note = JSON.stringify({ note: seft.productModel.note });
        // const productModelPost =  seft.productModel;
        //     // seft.productModel.specification = JSON.stringify({
        //     //   DVT: seft.productModel.specification,
        //     // });
        await axios
          .post(config.API_FAMILY + '/api/insertProduct', seft.productModel)
          .then(function (response) {
            // productModel = {};
            seft.dialog = false
            console.log(response.data.data)
            seft.$emit('refeshList')
          })
          .catch(function (error) {
            // handle error
            console.log(error)
          })
          .then(function () {
            console.log('then')

          // always executed
          })
      },
      refeshList () {
        this.$emit('refeshList')
      },
      resetValid () {
        console.log('resetValid')
        this.$refs.form.reset()
      // this.$refs.nameproduct.reset();
      },
      validate () {
        debugger
        console.log('vaild')
        this.$refs.form.validate()
        this.$nextTick(function () {
          // Product name
          if (!this.$refs.nameproduct.validate()) {
            this.$refs.nameproduct.focus()
          } else if (!this.$refs.spec.validate()) {
            this.$refs.spec.focus()
          } else if (!this.$refs.net.validate()) {
            this.$refs.net.focus()
          } else if (!this.$refs.category.validate()) {
            this.$refs.category.focus()
          } else if (!this.$refs.suppiler.validate()) {
            this.$refs.suppiler.focus()
          }

        //  this.setFirstFocusInput(".v-dialog--active",'input, textarea, select', '.v-text-field__slot input[required="required"]');
        })
      },
      chooseImage (ref) {
        if (ref === 'THUMB_1') {
          this.$refs.fileInput1.click()
        }
        if (ref === 'THUMB_2') {
          this.$refs.fileInput2.click()
        }
        if (ref === 'THUMB_3') {
          this.$refs.fileInput3.click()
        }
        if (ref === 'THUMB_4') {
          this.$refs.fileInput4.click()
        }
        if (ref === 'THUMB_5') {
          this.$refs.fileInput5.click()
        }
      },
      onSelectFile1 () {
        console.log('onSelectFile1')
        const input = this.$refs.fileInput1
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData1 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },

      onSelectFile2 () {
        console.log('onSelectFile2')
        const input = this.$refs.fileInput2
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData2 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile3 () {
        console.log('onSelectFile3')
        const input = this.$refs.fileInput3
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData3 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile4 () {
        console.log('onSelectFile4')
        const input = this.$refs.fileInput4
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData4 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile5 () {
        console.log('onSelectFile5')
        const input = this.$refs.fileInput5
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData5 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
    }, // end created
  } // End exxport defaul
</script>
<style scoped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
.table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
}
.image-input{
  display: block;
  max-width:100%;
  height:250px;
  cursor: pointer                  ;
  background-size: cover            ;
  background-position: center center;
  border-radius: 4px;
}
.image-input.thumb{
  display: block;
  max-width:70px;
  height:70px;
  cursor: pointer                  ;
  background-size: cover            ;
  background-position: center center;
  border-radius: 4px;
}
.placeholder{
  background: #F0F0F0     ;
  width: 100%             ;
  height: 100%            ;
  display: flex           ;
  justify-content: center ;
  align-items: center     ;
  color: #333             ;
  font-size: 18px         ;
  font-family: Helvetica   ;
}
.placeholder:hover{
  background: #E0E0E0;
}
.file-input{
  display: none;

}

.main-thumb .placeholder{
  border-radius: 8px;
}

</style>
